package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRDutyEdu;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDutyEduSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRDutyEdu] 服务对象接口
 */
public interface IHRDutyEduService extends IService<HRDutyEdu>{

    boolean create(HRDutyEdu et) ;
    void createBatch(List<HRDutyEdu> list) ;
    boolean update(HRDutyEdu et) ;
    void updateBatch(List<HRDutyEdu> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRDutyEdu get(String key) ;
    HRDutyEdu getDraft(HRDutyEdu et) ;
    boolean checkKey(HRDutyEdu et) ;
    boolean save(HRDutyEdu et) ;
    void saveBatch(List<HRDutyEdu> list) ;
    Page<HRDutyEdu> searchDefault(HRDutyEduSearchContext context) ;
    List<HRDutyEdu> selectByHrdutyid(String hrdutyid) ;
    void removeByHrdutyid(String hrdutyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRDutyEdu> getHrdutyeduByIds(List<String> ids) ;
    List<HRDutyEdu> getHrdutyeduByEntities(List<HRDutyEdu> entities) ;
}


